﻿Public Class Form1

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        LoadStateDataCombo()

    End Sub

    Private Sub LoadStateDataCombo()

        Dim intStateFileNbr As Integer
        Dim strStateAbbrev As String
        Dim strStateName As String
        intStateFileNbr = FreeFile()
        FileOpen(intStateFileNbr, My.Application.Info.DirectoryPath & "\STATES.TXT", OpenMode.Input)
        cboStates.Items.Clear()
        Do Until EOF(intStateFileNbr)
            Input(intStateFileNbr, strStateAbbrev)
            Input(intStateFileNbr, strStateName)
            cboStates.Items.Add(strStateAbbrev & " - " & strStateName)
        Loop
        FileClose(intStateFileNbr)

        cboStates.DropDownWidth = GetLongestItemWidth(cboStates)

    End Sub

    Private Function GetLongestItemWidth(ByVal combo As ComboBox) As Integer

        Dim longest As Integer
        Dim str As String
        Dim g As Graphics = Graphics.FromImage(New Bitmap(1, 1))
        'Enumerate the items in the combo
        For Each str In combo.Items
            Dim wid As Integer
            'Get the width of the item; if it's longer than the
            'longest one so far, store it.
            wid = g.MeasureString(str, combo.Font).Width
            If wid > longest Then longest = wid
        Next

        Return longest + 8

    End Function

End Class
